## hypre 2.15.1

=== src/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.8)
project (hypre)

# The version number.
set (HYPRE_VERSION 2.15.1)
set (HYPRE_DATE    2018/10/19)
set (HYPRE_TIME    00:00:00)
set (HYPRE_BUGS    hypre-support@llnl.gov)
set (HYPRE_SRCDIR  "${PROJECT_SOURCE_DIR}")

if (${hypre_SOURCE_DIR} STREQUAL ${hypre_BINARY_DIR})
  message(FATAL_ERROR "In-place build not allowed! Please use a separate build directory. See the Users Manual or INSTALL file for details.")
endif ()

# Set default installation directory, but provide a means for users to change
set (HYPRE_INSTALL_PREFIX "${PROJECT_SOURCE_DIR}/hypre" CACHE PATH
  "Installation directory for HYPRE")
set (CMAKE_INSTALL_PREFIX "${HYPRE_INSTALL_PREFIX}" CACHE INTERNAL "" FORCE)

# Set default compile optimization flag
set (HYPRE_BUILD_TYPE "Release" CACHE STRING
  "Optimization flags: set to Debug, Release, RelWithDebInfo, or MinSizeRel")
set (CMAKE_BUILD_TYPE "${HYPRE_BUILD_TYPE}" CACHE INTERNAL "" FORCE)

# Configuration options
option(HYPRE_SHARED               "Build a shared library" OFF)
option(HYPRE_BIGINT               "Use long long int for HYPRE_Int" OFF)
option(HYPRE_SINGLE               "Use float for HYPRE_Real" OFF)
option(HYPRE_LONG_DOUBLE          "Use long double for HYPRE_Real" OFF)
option(HYPRE_SEQUENTIAL           "Compile without MPI" OFF)
option(HYPRE_TIMING               "Use HYPRE timing routines" OFF)
option(HYPRE_USING_HYPRE_BLAS     "Use internal BLAS library" ON)
option(HYPRE_USING_HYPRE_LAPACK   "Use internal LAPACK library" ON)
option(HYPRE_NO_GLOBAL_PARTITION  "Use assumed partition" ON)
option(HYPRE_PRINT_ERRORS         "Print HYPRE errors" OFF)
option(HYPRE_USING_OPENMP         "Use OpenMP" OFF)
option(HYPRE_USING_FEI            "Use FEI" ON)
option(HYPRE_USING_CALIPER        "Use Caliper" OFF)  # TODO: Finish this cmake feature

if (HYPRE_SHARED)
  # FEI doesn't currently compile with shared
  set (HYPRE_USING_FEI OFF CACHE BOOL "" FORCE)
endif ()

if (HYPRE_BIGINT)
  set (HYPRE_USING_FEI OFF CACHE BOOL "" FORCE)
endif ()

if (HYPRE_SINGLE)
  set (HYPRE_USING_FEI OFF CACHE BOOL "" FORCE)
endif ()

if (HYPRE_LONG_DOUBLE)
  set (HYPRE_USING_FEI OFF CACHE BOOL "" FORCE)
endif ()

if (HYPRE_SEQUENTIAL)
  set (HYPRE_NO_GLOBAL_PARTITION OFF CACHE BOOL "" FORCE)
endif ()

#   --with-examples         Build example codes.
#   --with-fei              Use internal FEI routines.
#   --with-superlu          Use internal SuperLU routines.
#   --with-mli              Use MLI

# Headers and sources
set (HYPRE_HEADERS "")
set (HYPRE_SOURCES "")

# Headers and sources: .
list (APPEND HYPRE_HEADERS
  "${PROJECT_BINARY_DIR}/HYPRE_config.h"
  HYPREf.h
  HYPRE.h
)

# Headers and sources: blas
list (APPEND HYPRE_SOURCES
  blas/dasum.c
  blas/daxpy.c
  blas/dcopy.c
  blas/ddot.c
  blas/dgemm.c
  blas/dgemv.c
  blas/dger.c
  blas/dnrm2.c
  blas/drot.c
  blas/dscal.c
  blas/dswap.c
  blas/dsymm.c
  blas/dsymv.c
  blas/dsyr2.c
  blas/dsyr2k.c
  blas/dsyrk.c
  blas/dtrmm.c
  blas/dtrmv.c
  blas/dtrsm.c
  blas/dtrsv.c
  blas/f2c.c
  blas/idamax.c
  blas/lsame.c
  blas/xerbla.c
)

# Headers and sources: lapack
list (APPEND HYPRE_SOURCES
  lapack/dbdsqr.c
  lapack/dgebd2.c
  lapack/dgebrd.c
  lapack/dgelq2.c
  lapack/dgelqf.c
  lapack/dgels.c
  lapack/dgeqr2.c
  lapack/dgeqrf.c
  lapack/dgesvd.c
  lapack/dgetrf.c
  lapack/dgetri.c
  lapack/dgetrs.c
  lapack/dgetf2.c
  lapack/dlabad.c
  lapack/dlabrd.c
  lapack/dlacpy.c
  lapack/dlae2.c
  lapack/dlaev2.c
  lapack/dlamch.c
  lapack/dlange.c
  lapack/dlanst.c
  lapack/dlansy.c
  lapack/dlapy2.c
  lapack/dlarfb.c
  lapack/dlarf.c
  lapack/dlarfg.c
  lapack/dlarft.c
  lapack/dlartg.c
  lapack/dlas2.c
  lapack/dlascl.c
  lapack/dlaset.c
  lapack/dlasq1.c
  lapack/dlasq2.c
  lapack/dlasq3.c
  lapack/dlasq4.c
  lapack/dlasq5.c
  lapack/dlasq6.c
  lapack/dlasr.c
  lapack/dlasrt.c
  lapack/dlassq.c
  lapack/dlaswp.c
  lapack/dlasv2.c
  lapack/dlatrd.c
  lapack/dorg2l.c
  lapack/dorg2r.c
  lapack/dorgbr.c
  lapack/dorgl2.c
  lapack/dorglq.c
  lapack/dorgql.c
  lapack/dorgqr.c
  lapack/dorgtr.c
  lapack/dorm2r.c
  lapack/dormbr.c
  lapack/dorml2.c
  lapack/dormlq.c
  lapack/dormqr.c
  lapack/dpotf2.c
  lapack/dpotrf.c
  lapack/dpotrs.c
  lapack/dsteqr.c
  lapack/dsterf.c
  lapack/dsyev.c
  lapack/dsygs2.c
  lapack/dsygst.c
  lapack/dsygv.c
  lapack/dsytd2.c
  lapack/dsytrd.c
  lapack/dtrti2.c
  lapack/dtrtri.c
  lapack/ieeeck.c
  lapack/ilaenv.c
  lapack/lsame.c
  lapack/xerbla.c
)

# Headers and sources: utilities
list (APPEND HYPRE_HEADERS
  utilities/HYPRE_utilities.h
  utilities/_hypre_utilities.h
  utilities/hypre_hopscotch_hash.h
  utilities/HYPRE_error_f.h
  utilities/fortran.h
  utilities/fortran_matrix.h
)
list (APPEND HYPRE_SOURCES
  utilities/HYPRE_version.c
  utilities/amg_linklist.c
  utilities/binsearch.c
  utilities/exchange_data.c
  utilities/F90_HYPRE_error.c
  utilities/fortran_matrix.c
  utilities/hypre_ap.c
  utilities/hypre_complex.c
  utilities/hypre_error.c
  utilities/hypre_general.c
  utilities/hypre_hopscotch_hash.c
  utilities/hypre_memory.c
  utilities/hypre_merge_sort.c
  utilities/hypre_mpi_comm_f2c.c
  utilities/hypre_prefix_sum.c
  utilities/hypre_printf.c
  utilities/hypre_qsort.c
  utilities/mpistubs.c
  utilities/qsplit.c
  utilities/random.c
  utilities/threading.c
  utilities/timer.c
  utilities/timing.c
)

# Headers and sources: multivector
list (APPEND HYPRE_HEADERS
  multivector/csr_matmultivec.h
  multivector/interpreter.h
  multivector/multivector.h
  multivector/par_csr_matmultivec.h
  multivector/par_csr_pmvcomm.h
  multivector/par_multivector.h
  multivector/seq_multivector.h
  multivector/temp_multivector.h
)
list (APPEND HYPRE_SOURCES
  multivector/multivector.c
  multivector/temp_multivector.c
)

# Headers and sources: krylov
list (APPEND HYPRE_HEADERS
  krylov/HYPRE_krylov.h
  krylov/HYPRE_lobpcg.h
  krylov/HYPRE_MatvecFunctions.h
  krylov/krylov.h
  krylov/lobpcg.h
)
list (APPEND HYPRE_SOURCES
  krylov/bicgstab.c
  krylov/cgnr.c
  krylov/cogmres.c
  krylov/gmres.c
  krylov/flexgmres.c
  krylov/lgmres.c
  krylov/HYPRE_bicgstab.c
  krylov/HYPRE_cgnr.c
  krylov/HYPRE_gmres.c
  krylov/HYPRE_cogmres.c
  krylov/HYPRE_lgmres.c
  krylov/HYPRE_flexgmres.c
  krylov/HYPRE_pcg.c
  krylov/pcg.c
  krylov/HYPRE_lobpcg.c
  krylov/lobpcg.c
)

# Headers and sources: seq_mv
list (APPEND HYPRE_HEADERS
  seq_mv/HYPRE_seq_mv.h
  seq_mv/seq_mv.h
)
list (APPEND HYPRE_SOURCES
  seq_mv/csr_matop.c
  seq_mv/csr_matrix.c
  seq_mv/csr_matvec.c
  seq_mv/genpart.c
  seq_mv/HYPRE_csr_matrix.c
  seq_mv/HYPRE_mapped_matrix.c
  seq_mv/HYPRE_multiblock_matrix.c
  seq_mv/HYPRE_vector.c
  seq_mv/mapped_matrix.c
  seq_mv/multiblock_matrix.c
  seq_mv/vector.c
)

# Headers and sources: parcsr_mv
list (APPEND HYPRE_HEADERS
  parcsr_mv/HYPRE_parcsr_mv.h
  parcsr_mv/_hypre_parcsr_mv.h
)
list (APPEND HYPRE_SOURCES
  parcsr_mv/communicationT.c
  parcsr_mv/F90_HYPRE_parcsr_matrix.c
  parcsr_mv/F90_HYPRE_parcsr_vector.c
  parcsr_mv/F90_parcsr_matrix.c
  parcsr_mv/F90_par_vector.c
  parcsr_mv/HYPRE_parcsr_matrix.c
  parcsr_mv/HYPRE_parcsr_vector.c
  parcsr_mv/new_commpkg.c
  parcsr_mv/numbers.c
  parcsr_mv/par_csr_aat.c
  parcsr_mv/par_csr_assumed_part.c
  parcsr_mv/par_csr_bool_matop.c
  parcsr_mv/par_csr_bool_matrix.c
  parcsr_mv/par_csr_communication.c
  parcsr_mv/par_csr_matop.c
  parcsr_mv/par_csr_matrix.c
  parcsr_mv/par_csr_matop_marked.c
  parcsr_mv/par_csr_matvec.c
  parcsr_mv/par_vector.c
  parcsr_mv/par_make_system.c
)

# Headers and sources: parcsr_block_mv
list (APPEND HYPRE_HEADERS
  parcsr_block_mv/par_csr_block_matrix.h
  parcsr_block_mv/csr_block_matrix.h
)
list (APPEND HYPRE_SOURCES
  parcsr_block_mv/csr_block_matrix.c
  parcsr_block_mv/csr_block_matvec.c
  parcsr_block_mv/par_csr_block_matrix.c
  parcsr_block_mv/par_csr_block_matvec.c
  parcsr_block_mv/par_csr_block_comm.c
  parcsr_block_mv/par_csr_block_rap.c
  parcsr_block_mv/par_csr_block_rap_communication.c
  parcsr_block_mv/par_csr_block_interp.c
  parcsr_block_mv/par_csr_block_relax.c
  parcsr_block_mv/par_block_nodal_systems.c
)

# Headers and sources: distributed_matrix
list (APPEND HYPRE_HEADERS
  distributed_matrix/distributed_matrix.h
)
list (APPEND HYPRE_SOURCES
  distributed_matrix/distributed_matrix.c
  distributed_matrix/HYPRE_distributed_matrix.c
  distributed_matrix/distributed_matrix_ISIS.c
  distributed_matrix/distributed_matrix_PETSc.c
  distributed_matrix/distributed_matrix_parcsr.c
)

# Headers and sources: IJ_mv
list (APPEND HYPRE_HEADERS
  IJ_mv/HYPRE_IJ_mv.h
  IJ_mv/_hypre_IJ_mv.h
)
list (APPEND HYPRE_SOURCES
  IJ_mv/aux_parcsr_matrix.c
  IJ_mv/aux_par_vector.c
  IJ_mv/F90_HYPRE_IJMatrix.c
  IJ_mv/F90_HYPRE_IJVector.c
  IJ_mv/F90_IJMatrix.c
  IJ_mv/HYPRE_IJMatrix.c
  IJ_mv/HYPRE_IJVector.c
  IJ_mv/IJ_assumed_part.c
  IJ_mv/IJMatrix.c
  IJ_mv/IJMatrix_parcsr.c
  IJ_mv/IJVector.c
  IJ_mv/IJVector_parcsr.c
)

# Headers and sources: matrix_matrix
list (APPEND HYPRE_HEADERS
  matrix_matrix/HYPRE_matrix_matrix_protos.h
)
list (APPEND HYPRE_SOURCES
  matrix_matrix/HYPRE_ConvertParCSRMatrixToDistributedMatrix.c
  matrix_matrix/HYPRE_ConvertPETScMatrixToDistributedMatrix.c
)

# Headers and sources: distributed_ls/pilut
list (APPEND HYPRE_HEADERS
  distributed_ls/pilut/HYPRE_DistributedMatrixPilutSolver_protos.h
  distributed_ls/pilut/HYPRE_DistributedMatrixPilutSolver_types.h
)
list (APPEND HYPRE_SOURCES
  distributed_ls/pilut/comm.c
  distributed_ls/pilut/debug.c
  distributed_ls/pilut/distributed_qsort.c
  distributed_ls/pilut/distributed_qsort_si.c
  distributed_ls/pilut/HYPRE_DistributedMatrixPilutSolver.c
  distributed_ls/pilut/ilut.c
  distributed_ls/pilut/parilut.c
  distributed_ls/pilut/parutil.c
  distributed_ls/pilut/pblas1.c
  distributed_ls/pilut/serilut.c
  distributed_ls/pilut/trifactor.c
  distributed_ls/pilut/util.c
)

# Headers and sources: distributed_ls/ParaSails
list (APPEND HYPRE_SOURCES
  distributed_ls/ParaSails/ConjGrad.c
  distributed_ls/ParaSails/DiagScale.c
  distributed_ls/ParaSails/FGmres.c
  distributed_ls/ParaSails/Hash.c
  distributed_ls/ParaSails/hypre_ParaSails.c
  distributed_ls/ParaSails/LoadBal.c
  distributed_ls/ParaSails/Matrix.c
  distributed_ls/ParaSails/Mem.c
  distributed_ls/ParaSails/Numbering.c
  distributed_ls/ParaSails/OrderStat.c
  distributed_ls/ParaSails/ParaSails.c
  distributed_ls/ParaSails/PrunedRows.c
  distributed_ls/ParaSails/RowPatt.c
  distributed_ls/ParaSails/StoredRows.c
)

# Headers and sources: distributed_ls/Euclid
list (APPEND HYPRE_SOURCES
  distributed_ls/Euclid/blas_dh.c
  distributed_ls/Euclid/Euclid_apply.c
  distributed_ls/Euclid/Euclid_dh.c
  distributed_ls/Euclid/ExternalRows_dh.c
  distributed_ls/Euclid/Factor_dh.c
  distributed_ls/Euclid/getRow_dh.c
  distributed_ls/Euclid/globalObjects.c
  distributed_ls/Euclid/Hash_dh.c
  distributed_ls/Euclid/Hash_i_dh.c
  distributed_ls/Euclid/ilu_mpi_bj.c
  distributed_ls/Euclid/ilu_mpi_pilu.c
  distributed_ls/Euclid/ilu_seq.c
  distributed_ls/Euclid/io_dh.c
  distributed_ls/Euclid/krylov_dh.c
  distributed_ls/Euclid/Mat_dh.c
  distributed_ls/Euclid/mat_dh_private.c
  distributed_ls/Euclid/MatGenFD.c
  distributed_ls/Euclid/Mem_dh.c
  distributed_ls/Euclid/Numbering_dh.c
  distributed_ls/Euclid/Parser_dh.c
  distributed_ls/Euclid/shellSort_dh.c
  distributed_ls/Euclid/sig_dh.c
  distributed_ls/Euclid/SortedList_dh.c
  distributed_ls/Euclid/SortedSet_dh.c
  distributed_ls/Euclid/SubdomainGraph_dh.c
  distributed_ls/Euclid/TimeLog_dh.c
  distributed_ls/Euclid/Timer_dh.c
  distributed_ls/Euclid/Vec_dh.c
)

# Headers and sources: parcsr_ls
list (APPEND HYPRE_HEADERS
  parcsr_ls/HYPRE_parcsr_ls.h
  parcsr_ls/_hypre_parcsr_ls.h
)
list (APPEND HYPRE_SOURCES
  parcsr_ls/amg_hybrid.c
  parcsr_ls/aux_interp.c
  parcsr_ls/F90_hypre_laplace.c
  parcsr_ls/F90_HYPRE_parcsr_amg.c
  parcsr_ls/F90_HYPRE_parcsr_bicgstab.c
  parcsr_ls/F90_HYPRE_parcsr_block.c
  parcsr_ls/F90_HYPRE_parcsr_cgnr.c
  parcsr_ls/F90_HYPRE_parcsr_Euclid.c
  parcsr_ls/F90_HYPRE_parcsr_gmres.c
  parcsr_ls/F90_HYPRE_parcsr_cogmres.c

=== src/Makefile ===
#BHEADER**********************************************************************
# Copyright (c) 2008,  Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory.
# This file is part of HYPRE.  See file COPYRIGHT for details.
#
# HYPRE is free software; you can redistribute it and/or modify it under the
# terms of the GNU Lesser General Public License (as published by the Free
# Software Foundation) version 2.1 dated February 1999.
#
# $Revision$
#EHEADER**********************************************************************

default: all

# Include all variables defined by configure
include config/Makefile.config

# These are the directories for internal blas, lapack and general utilities
HYPRE_BASIC_DIRS =\
 blas\
 lapack\
 utilities

#These are the directories for multivector
HYPRE_MULTIVEC_DIRS =\
 multivector

# These are the directories for the generic Krylov solvers
HYPRE_KRYLOV_DIRS =\
 krylov

#These are the directories for the IJ interface
HYPRE_IJ_DIRS =\
 seq_mv\
 parcsr_mv\
 parcsr_block_mv\
 distributed_matrix\
 IJ_mv\
 matrix_matrix\
 distributed_ls\
 parcsr_ls

#These are the directories for the structured interface
HYPRE_STRUCT_DIRS =\
 struct_mv\
 struct_ls

#These are the directories for the semi-structured interface
HYPRE_SSTRUCT_DIRS =\
 sstruct_mv\
 sstruct_ls

#These are the directories for the FEI
HYPRE_FEI_DIRS = ${HYPRE_FEI_SRC_DIR}

#This is the lib directory
HYPRE_LIBS_DIRS = lib

#This is the documentation directory
HYPRE_DOCS_DIRS = docs

#This is the test-driver directory
HYPRE_TEST_DIRS = test

#This is the examples directory
HYPRE_EXAMPLE_DIRS = examples

# These are directories that are officially in HYPRE
HYPRE_DIRS =\
 ${HYPRE_BASIC_DIRS}\
 ${HYPRE_MULTIVEC_DIRS}\
 ${HYPRE_KRYLOV_DIRS}\
 ${HYPRE_IJ_DIRS}\
 ${HYPRE_STRUCT_DIRS}\
 ${HYPRE_SSTRUCT_DIRS}\
 ${HYPRE_FEI_DIRS}\
 ${HYPRE_LIBS_DIRS}

# These are directories that are not yet officially in HYPRE
HYPRE_EXTRA_DIRS =\
 ${HYPRE_DOCS_DIRS}\
 ${HYPRE_TEST_DIRS}\
 seq_ls/pamg

#################################################################
# Targets
#################################################################

all:
	@ \
	mkdir -p ${HYPRE_BUILD_DIR}/include; \
	mkdir -p ${HYPRE_BUILD_DIR}/lib; \
	cp -fR HYPRE_config.h ${HYPRE_BUILD_DIR}/include/.; \
	cp -fR $(srcdir)/HYPRE.h ${HYPRE_BUILD_DIR}/include/.; \
	cp -fR $(srcdir)/HYPREf.h ${HYPRE_BUILD_DIR}/include/.; \
	for i in ${HYPRE_DIRS}; \
	do \
	  echo "Making $$i ..."; \
	  (cd $$i && $(MAKE) $@) || exit 1; \
	  echo ""; \
	done

help:
	@echo "     "
	@echo "************************************************************"
	@echo " HYPRE Make System Targets"
	@echo "   (using GNU-standards)"
	@echo "     "
	@echo "all:"
	@echo "     default target in all directories"
	@echo "     compile the entire program"
	@echo "     does not rebuild documentation"
	@echo "     "
	@echo "help:"
	@echo "     prints details of each target"
	@echo "     "
	@echo "install:"
	@echo "     compile the program and copy executables, libraries, etc"
	@echo "        to the file names where they reside for actual use"
	@echo "     executes mkinstalldirs script to create directories needed"
	@echo "     "
	@echo "clean:"
	@echo "     deletes all files from the current directory that are normally"
	@echo "        created by building the program"
	@echo "     "
	@echo "distclean:"
	@echo "     deletes all files from the current directory that are"
	@echo "        created by configuring or building the program"
	@echo "     "
	@echo "tags:"
	@echo "     runs etags to create tags table"
	@echo "     file is named TAGS and is saved in current directory"
	@echo "     "
	@echo "test:"
	@echo "     depends on the all target to be completed"
	@echo "     removes existing temporary installation sub-directory"
	@echo "     creates a temporary installation sub-directory"
	@echo "     copies all libHYPRE* and *.h files to the temporary locations"
	@echo "     builds the test drivers; linking to the temporary installation"
	@echo "        directories to simulate how application codes will link to HYPRE"
	@echo "     "
	@echo "check:"
	@echo "     runs a small driver test to verify a working library"
	@echo "     use CHECKRUN=<mpirun routine> if needed combined with"
	@echo "     PARMS='-P px py pz' where px*py*pz must be number of"
	@echo "     processes set in CHECKRUN"
	@echo "     "
	@echo "     "
	@echo "checkpar:"
	@echo "     runs several regression test to verify a working library."
	@echo "     Use parameter CHECKRUN='<mpirun routine -n>' if needed."
	@echo "     If CHECKRUN is not set, 'mpirun -np' is used."
	@echo "     "
	@echo "     "
	@echo "************************************************************"

test: all
	@ \
	echo "Making test drivers ..."; \
	(cd test; $(MAKE) clean; $(MAKE) all)

check:
	@ \
	echo "Checking the library ..."; \
	(cd test; $(MAKE) all); \
	(cd test; $(CHECKRUN) ./ij $(PARMS) 2> ij.err); \
	(cd test; $(CHECKRUN) ./struct $(PARMS) 2> struct.err); \
	(cd test; cp -f TEST_sstruct/sstruct.in.default .; $(CHECKRUN) ./sstruct $(PARMS) 2> sstruct.err); \
	(cd test; ls -l ij.err struct.err sstruct.err)

checkpar:
	@ \
        echo "Checking the library ..."; \
        (cd test; $(MAKE) all); \
        echo "Testing IJ ..."; \
        (cd test; ./runtest.sh -tol 1.e-06 -mpi "$(CHECKRUN)" TEST_ij/solvers.sh); \
        (cd test; ./checktest.sh); \
        (cd test; ./cleantest.sh); \
        echo "Testing Struct ..."; \
        (cd test; ./runtest.sh -tol 1.e-06 -mpi "$(CHECKRUN)" TEST_struct/solvers.sh); \
        (cd test; ./checktest.sh); \
        (cd test; ./cleantest.sh); \
        echo "Testing SStruct ..."; \
        (cd test; ./runtest.sh -tol 1.e-06 -mpi "$(CHECKRUN)" TEST_sstruct/solvers.sh); \
        (cd test; ./checktest.sh); \
        (cd test; ./cleantest.sh); 

install: all
	@ \
	echo "Installing hypre ..."; \
	${HYPRE_SRC_TOP_DIR}/config/mkinstalldirs ${HYPRE_LIB_INSTALL} ${HYPRE_INC_INSTALL}; \
	HYPRE_PWD=`pwd`; \
	cd ${HYPRE_BUILD_DIR}/lib; HYPRE_FROMDIR=`pwd`; \
	cd $$HYPRE_PWD; \
	cd ${HYPRE_LIB_INSTALL};   HYPRE_TODIR=`pwd`; \
	if [ "$$HYPRE_FROMDIR" != "$$HYPRE_TODIR" ]; \
	then \
	  cp -fR $$HYPRE_FROMDIR/* $$HYPRE_TODIR; \
	fi; \
	cd ${HYPRE_BUILD_DIR}/include; HYPRE_FROMDIR=`pwd`; \
	cd $$HYPRE_PWD; \
	cd ${HYPRE_INC_INSTALL};       HYPRE_TODIR=`pwd`; \
	if [ "$$HYPRE_FROMDIR" != "$$HYPRE_TODIR" ]; \
	then \
	  cp -fR $$HYPRE_FROMDIR/* $$HYPRE_TODIR; \
	fi; \
	cd $$HYPRE_PWD; \
	chmod -R a+rX,u+w,go-w ${HYPRE_LIB_INSTALL}; \
	chmod -R a+rX,u+w,go-w ${HYPRE_INC_INSTALL}; \
	echo

clean:
	@ \
	rm -Rf hypre; \
	for i in ${HYPRE_DIRS} ${HYPRE_EXTRA_DIRS} ${HYPRE_EXAMPLE_DIRS}; \
	do \
	  if [ -f $$i/Makefile ]; \
	  then \
	    echo "Cleaning $$i ..."; \
	    (cd $$i && $(MAKE) $@) || exit 1; \
	  fi; \
	done
	rm -rf tca.map pchdir *inslog*

distclean:
	@ \
	rm -Rf hypre; \
	for i in ${HYPRE_DIRS} ${HYPRE_EXTRA_DIRS} ${HYPRE_EXAMPLE_DIRS} examples/docs; \
	do \
	  if [ -d $$i ]; \
	  then \
	    echo "Dist-Cleaning $$i ..."; \
	    (cd $$i && $(MAKE) $@) || exit 1; \
	  fi; \
	done
	rm -rf tca.map pchdir *inslog*
	rm -rf ./config/Makefile.config
	rm -rf ./TAGS
	rm -rf ./autom4te.cache
	rm -rf ./config.log
	rm -rf ./config.status
	rm -rf ./HYPRE_config.h

tags:
	find . -name "*.c" -o -name "*.C" -o -name "*.h" -o \
	-name "*.c??" -o -name "*.h??" -o -name "*.f" | etags -

=== src/IJ_mv/Makefile ===
#BHEADER**********************************************************************
# Copyright (c) 2008,  Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory.
# This file is part of HYPRE.  See file COPYRIGHT for details.
#
# HYPRE is free software; you can redistribute it and/or modify it under the
# terms of the GNU Lesser General Public License (as published by the Free
# Software Foundation) version 2.1 dated February 1999.
#
# $Revision$
#EHEADER**********************************************************************


include ../config/Makefile.config

CINCLUDES = ${INCLUDES} ${MPIINCLUDE}

C_COMPILE_FLAGS =\
 -I..\
 -I$(srcdir)/..\
 -I$(srcdir)/../utilities\
 -I$(srcdir)/../struct_mv\
 -I$(srcdir)/../seq_mv\
 -I$(srcdir)/../parcsr_mv\
 -I$(srcdir)/../parcsr_ls\
 ${CINCLUDES}

HEADERS =\
 aux_parcsr_matrix.h\
 aux_par_vector.h\
 HYPRE_IJ_mv.h\
 _hypre_IJ_mv.h\
 IJ_matrix.h\
 IJ_vector.h

EXTRA_FILES =\
 IJMatrix_isis.c\
 IJMatrix_petsc.c

FILES =\
 aux_parcsr_matrix.c\
 aux_par_vector.c\
 F90_HYPRE_IJMatrix.c\
 F90_HYPRE_IJVector.c\
 F90_IJMatrix.c\
 HYPRE_IJMatrix.c\
 HYPRE_IJVector.c\
 IJ_assumed_part.c\
 IJMatrix.c\
 IJMatrix_parcsr.c\
 IJVector.c\
 IJVector_parcsr.c

OBJS = ${FILES:.c=.o}

SONAME = libHYPRE_IJ_mv-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}

##################################################################
# Targets
##################################################################

all: libHYPRE_IJ_mv${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_BUILD_DIR)/include
	cp -fR $(srcdir)/_hypre_IJ_mv.h $(HYPRE_BUILD_DIR)/include
#	cp -fR libHYPRE* $(HYPRE_BUILD_DIR)/lib

install: libHYPRE_IJ_mv${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_INC_INSTALL)
	cp -fR $(srcdir)/_hypre_IJ_mv.h $(HYPRE_INC_INSTALL)
#	cp -fR libHYPRE* $(HYPRE_LIB_INSTALL)

clean:
	rm -f *.o libHYPRE*
	rm -rf pchdir tca.map *inslog*

distclean: clean

##################################################################
# Rules
##################################################################

libHYPRE_IJ_mv.a: ${OBJS}
	@echo  "Building $@ ... "
	${AR} $@ ${OBJS}
	${RANLIB} $@

libHYPRE_IJ_mv.so libHYPRE_IJ_mv.dylib: ${OBJS}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${OBJS} ${SHARED_SET_SONAME}${SONAME}
	ln -s ${SONAME} $@

${OBJS}: ${HEADERS}

=== src/distributed_matrix/Makefile ===
#BHEADER**********************************************************************
# Copyright (c) 2008,  Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory.
# This file is part of HYPRE.  See file COPYRIGHT for details.
#
# HYPRE is free software; you can redistribute it and/or modify it under the
# terms of the GNU Lesser General Public License (as published by the Free
# Software Foundation) version 2.1 dated February 1999.
#
# $Revision$
#EHEADER**********************************************************************


include ../config/Makefile.config

CINCLUDES = ${INCLUDES} ${MPIINCLUDE}

C_COMPILE_FLAGS = \
 -I..\
 -I$(srcdir)/..\
 -I$(srcdir)/../utilities\
 -I$(srcdir)/../parcsr_mv\
 -I$(srcdir)/../seq_mv\
 ${CINCLUDES}

EXTRA_HEADERS = internal_protos.h

HEADERS =\
 distributed_matrix.h\
 HYPRE_distributed_matrix_mv.h\
 HYPRE_distributed_matrix_protos.h\
 HYPRE_distributed_matrix_types.h

FILES =\
 distributed_matrix.c\
 HYPRE_distributed_matrix.c\
 distributed_matrix_ISIS.c\
 distributed_matrix_PETSc.c\
 distributed_matrix_parcsr.c

OBJS = ${FILES:.c=.o}

SONAME = libHYPRE_DistributedMatrix-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}

##################################################################
# Targets
##################################################################

all: libHYPRE_DistributedMatrix${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/distributed_matrix.h $(HYPRE_BUILD_DIR)/include
#	cp -fR libHYPRE* $(HYPRE_BUILD_DIR)/lib

install: libHYPRE_DistributedMatrix${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/distributed_matrix.h $(HYPRE_INC_INSTALL)
#	cp -fR libHYPRE* $(HYPRE_LIB_INSTALL)

clean:
	rm -f *.o libHYPRE*
	rm -rf pchdir tca.map *inslog*

distclean: clean

##################################################################
# Rules
##################################################################

libHYPRE_DistributedMatrix.a: ${OBJS}
	@echo  "Building $@ ... "
	${AR} $@ ${OBJS}
	${RANLIB} $@

libHYPRE_DistributedMatrix.so libHYPRE_DistributedMatrix.dylib: ${OBJS}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${OBJS} ${SHARED_SET_SONAME}${SONAME}
	ln -s ${SONAME} $@

${OBJS}: ${HEADERS}

=== src/lapack/Makefile ===
#BHEADER**********************************************************************
# Copyright (c) 2008,  Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory.
# This file is part of HYPRE.  See file COPYRIGHT for details.
#
# HYPRE is free software; you can redistribute it and/or modify it under the
# terms of the GNU Lesser General Public License (as published by the Free
# Software Foundation) version 2.1 dated February 1999.
#
# $Revision$
#EHEADER**********************************************************************


###  the inclusion of these routines based on the configure options.

include ../config/Makefile.config

C_COMPILE_FLAGS = ${INCLUDES} -I.. -I../blas -I../utilities

LAPACK_HEADERS =  f2c.h hypre_lapack.h
LAPACK_FILES = \
 dbdsqr.c\
 dgebd2.c\
 dgebrd.c\
 dgelq2.c\
 dgelqf.c\
 dgels.c\
 dgeqr2.c\
 dgeqrf.c\
 dgesvd.c\
 dgetrf.c\
 dgetri.c\
 dgetrs.c\
 dgetf2.c\
 dlabad.c\
 dlabrd.c\
 dlacpy.c\
 dlae2.c\
 dlaev2.c\
 dlange.c\
 dlanst.c\
 dlansy.c\
 dlapy2.c\
 dlarfb.c\
 dlarf.c\
 dlarfg.c\
 dlarft.c\
 dlartg.c\
 dlas2.c\
 dlascl.c\
 dlaset.c\
 dlasq1.c\
 dlasq2.c\
 dlasq3.c\
 dlasq4.c\
 dlasq5.c\
 dlasq6.c\
 dlasr.c\
 dlasrt.c\
 dlassq.c\
 dlaswp.c\
 dlasv2.c\
 dlatrd.c\
 dorg2l.c\
 dorg2r.c\
 dorgbr.c\
 dorgl2.c\
 dorglq.c\
 dorgql.c\
 dorgqr.c\
 dorgtr.c\
 dorm2r.c\
 dormbr.c\
 dorml2.c\
 dormlq.c\
 dormqr.c\
 dpotf2.c\
 dpotrf.c\
 dpotrs.c\
 dsteqr.c\
 dsterf.c\
 dsyev.c\
 dsygs2.c\
 dsygst.c\
 dsygv.c\
 dsytd2.c\
 dsytrd.c\
 dtrtri.c\
 dtrti2.c\
 ieeeck.c\
 ilaenv.c\
 lsame.c\
 xerbla.c

OBJS = ${LAPACK_FILES:.c=.o}

#################################################################
# Targets
#################################################################

all: ${OBJS} dlamch.o

install: all
	cp -fR $(srcdir)/_hypre_lapack.h $(HYPRE_INC_INSTALL)

clean:
	rm -rf *.o

distclean: clean

#################################################################
# Rules
#################################################################

# compile without optimization
dlamch.o : dlamch.c ${LAPACK_HEADERS}
	${CC} ${CFLAGS} -c dlamch.c

${OBJS}: ${LAPACK_HEADERS}

=== src/lib/Makefile ===
#BHEADER**********************************************************************
# Copyright (c) 2008,  Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory.
# This file is part of HYPRE.  See file COPYRIGHT for details.
#
# HYPRE is free software; you can redistribute it and/or modify it under the
# terms of the GNU Lesser General Public License (as published by the Free
# Software Foundation) version 2.1 dated February 1999.
#
# $Revision$
#EHEADER**********************************************************************

include ../config/Makefile.config

FEIHYPREFILES = ${HYPRE_FEI_HYPRE_FILES}
FEMLIFILES = ${HYPRE_FEI_FEMLI_FILES}
IJMVFILES = ${HYPRE_SRC_TOP_DIR}/IJ_mv/*.o
EUCLIDFILES = ${HYPRE_SRC_TOP_DIR}/distributed_ls/Euclid/*.o
PARASAILSFILES = ${HYPRE_SRC_TOP_DIR}/distributed_ls/ParaSails/*.o
PILUTFILES = ${HYPRE_SRC_TOP_DIR}/distributed_ls/pilut/*.o
DISTMATRIXFILES = ${HYPRE_SRC_TOP_DIR}/distributed_matrix/*.o
KRYLOVFILES = ${HYPRE_SRC_TOP_DIR}/krylov/*.o
MATMATFILES = ${HYPRE_SRC_TOP_DIR}/matrix_matrix/*.o
MULTIVECFILES = ${HYPRE_SRC_TOP_DIR}/multivector/*.o
PARCSRLSFILES = ${HYPRE_SRC_TOP_DIR}/parcsr_ls/*.o
PARCSRMVFILES = ${HYPRE_SRC_TOP_DIR}/parcsr_mv/*.o
PARCSRBLOCKMVFILES = ${HYPRE_SRC_TOP_DIR}/parcsr_block_mv/*.o
SEQMVFILES = ${HYPRE_SRC_TOP_DIR}/seq_mv/*.o
SSTRUCTLSFILES = ${HYPRE_SRC_TOP_DIR}/sstruct_ls/*.o
SSTRUCTMVFILES = ${HYPRE_SRC_TOP_DIR}/sstruct_mv/*.o
STRUCTLSFILES = ${HYPRE_SRC_TOP_DIR}/struct_ls/*.o
STRUCTMVFILES = ${HYPRE_SRC_TOP_DIR}/struct_mv/*.o
UTILITIESFILES = ${HYPRE_SRC_TOP_DIR}/utilities/*.o
BLASFILES = ${HYPRE_SRC_TOP_DIR}/blas/*.o
LAPACKFILES = ${HYPRE_SRC_TOP_DIR}/lapack/*.o

FILES_HYPRE = \
$(FEIHYPREFILES)\
$(FEMLIFILES)\
$(IJMVFILES)\
$(EUCLIDFILES)\
$(PARASAILSFILES)\
$(PILUTFILES)\
$(DISTMATRIXFILES)\
$(KRYLOVFILES)\
$(MATMATFILES)\
$(MULTIVECFILES)\
$(PARCSRLSFILES)\
$(PARCSRMVFILES)\
$(PARCSRBLOCKMVFILES)\
$(SEQMVFILES)\
$(SSTRUCTLSFILES)\
$(SSTRUCTMVFILES)\
$(STRUCTLSFILES)\
$(STRUCTMVFILES)\
$(UTILITIESFILES)\
$(BLASFILES)\
$(LAPACKFILES)

SONAME = libHYPRE-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}
SOLIBS = ${MPILIBDIRS} ${MPILIBS} ${LAPACKLIBDIRS} ${LAPACKLIBS}\
 ${BLASLIBDIRS} ${BLASLIBS} ${LIBS} ${FLIBS}


##################################################################
# Targets
##################################################################

all: libHYPRE${HYPRE_LIB_SUFFIX}
	cp -fR libHYPRE* ${HYPRE_BUILD_DIR}/lib

install: all
	cp -fR libHYPRE* ${HYPRE_LIB_INSTALL}

clean:
	rm -f *.o libHYPRE*
	rm -rf pchdir tca.map *inslog*

distclean: clean

##################################################################
# Rules
##################################################################

libHYPRE.a: ${FILES_HYPRE}
	@echo  "Building libHYPRE ... "
	${AR} $@ $(FEIHYPREFILES) $(FEMLIFILES) $(IJMVFILES)
	${AR} $@ $(EUCLIDFILES)
	${AR} $@ $(PARASAILSFILES)
	${AR} $@ $(PILUTFILES)
	${AR} $@ $(DISTMATRIXFILES)
	${AR} $@ $(KRYLOVFILES)
	${AR} $@ $(MATMATFILES)
	${AR} $@ $(MULTIVECFILES)
	${AR} $@ $(PARCSRLSFILES)
	${AR} $@ $(PARCSRMVFILES)
	${AR} $@ $(PARCSRBLOCKMVFILES)
	${AR} $@ $(SEQMVFILES)
	${AR} $@ $(SSTRUCTLSFILES)
	${AR} $@ $(SSTRUCTMVFILES)
	${AR} $@ $(STRUCTLSFILES)
	${AR} $@ $(STRUCTMVFILES)
	${AR} $@ $(UTILITIESFILES) $(BLASFILES) $(LAPACKFILES)
	${RANLIB} $@

libHYPRE.so libHYPRE.dylib: ${FILES_HYPRE}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${FILES_HYPRE} ${SOLIBS} ${SHARED_SET_SONAME}${SONAME} ${SHARED_OPTIONS} ${LDFLAGS}
	ln -s ${SONAME} $@

=== src/parcsr_block_mv/Makefile ===
#BHEADER**********************************************************************
# Copyright (c) 2008,  Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory.
# This file is part of HYPRE.  See file COPYRIGHT for details.
#
# HYPRE is free software; you can redistribute it and/or modify it under the
# terms of the GNU Lesser General Public License (as published by the Free
# Software Foundation) version 2.1 dated February 1999.
#
# $Revision$
#EHEADER**********************************************************************


include ../config/Makefile.config

CINCLUDES = ${INCLUDES} ${MPIINCLUDE}

C_COMPILE_FLAGS = \
 -I..\
 -I$(srcdir)\
 -I$(srcdir)/..\
 -I$(srcdir)/../utilities\
 -I$(srcdir)/../multivector\
 -I$(srcdir)/../seq_mv\
 -I$(srcdir)/../parcsr_mv\
 -I$(srcdir)/../parcsr_ls\
 -I$(srcdir)/../IJ_mv\
 -I$(srcdir)/../krylov\
 $(SUPERLU_INCLUDE)\
 $(DSUPERLU_INCLUDE)\
 ${CINCLUDES}

LFLAGS = \
  -L. -lHYPRE_parcsr_block_mv -L../hypre/lib -lHYPRE_krylov \
      -lHYPRE_parcsr_ls -lHYPRE_ParaSails -lHYPRE_Euclid \
      -lHYPRE_DistributedMatrixPilutSolver -lHYPRE_IJ_mv \
      -lHYPRE_parcsr_mv -lHYPRE_seq_mv -lHYPRE_DistributedMatrix \
      -lHYPRE_MatrixMatrix -lHYPRE_utilities -lm
# -L. -lHYPRE_parcsr_block_mv -L../hypre/lib -lHYPRE_LSI -lHYPRE_superlu -lm

HEADERS =\
 csr_block_matrix.h\
 par_csr_block_matrix.h

FILES =\
 csr_block_matrix.c\
 csr_block_matvec.c\
 par_csr_block_matrix.c\
 par_csr_block_matvec.c\
 par_csr_block_comm.c\
 par_csr_block_rap.c\
 par_csr_block_rap_communication.c\
 par_csr_block_interp.c\
 par_csr_block_relax.c\
 par_block_nodal_systems.c

EXTRA_FILES =

DRIVER_FILES =

OBJS = ${FILES:.c=.o}
DRIVER_OBJS = ${DRIVER_FILES:.c=.o}

SONAME = libHYPRE_parcsr_block_mv-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}

##################################################################
# Targets
##################################################################

all: libHYPRE_parcsr_block_mv${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/par_csr_block_matrix.h $(HYPRE_BUILD_DIR)/include	
	cp -fR $(srcdir)/csr_block_matrix.h $(HYPRE_BUILD_DIR)/include
#	cp -fR libHYPRE_* $(HYPRE_BUILD_DIR)/lib/.

driver: driver.o libHYPRE_parcsr_block_mv${HYPRE_LIB_SUFFIX}
	@echo  "Linking" $@ "... "
	${CC} -o driver driver.o ${LFLAGS} 

driver_matvec: driver_matvec.o
	@echo  "Linking" $@ "... "
	${CC} -o driver_matvec driver_matvec.o ${LFLAGS} 

driver_matmul: driver_matmul.o libHYPRE_parcsr_mv${HYPRE_LIB_SUFFIX}
	@echo  "Linking" $@ "... "
	${CC} -o driver_matmul driver_matmul.o ${LFLAGS} 

driver_boolmatmul: driver_boolmatmul.o libHYPRE_parcsr_mv${HYPRE_LIB_SUFFIX}
	@echo  "Linking" $@ "... "
	${CC} -o driver_boolmatmul driver_boolmatmul.o ${LFLAGS} 

driver_aat: driver_aat.o libHYPRE_parcsr_mv${HYPRE_LIB_SUFFIX}
	@echo  "Linking" $@ "... "
	${CC} -o driver_aat driver_aat.o ${LFLAGS} 

driver_boolaat: driver_boolaat.o libHYPRE_parcsr_mv${HYPRE_LIB_SUFFIX}
	@echo  "Linking" $@ "... "
	${CC} -o driver_boolaat driver_boolaat.o ${LFLAGS} 

install: libHYPRE_parcsr_block_mv${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/par_csr_block_matrix.h $(HYPRE_INC_INSTALL)/.
	cp -fR $(srcdir)/csr_block_matrix.h $(HYPRE_INC_INSTALL)/.
#	cp -fR libHYPRE_* $(HYPRE_LIB_INSTALL)/.

clean:
	rm -rf *.o libHYPRE_*
	rm -f driver driver_matvec driver_matmul

distclean: clean

##################################################################
# Rules
##################################################################

libHYPRE_parcsr_block_mv.a: ${OBJS}
	@echo  "Building $@ ... "
	${AR} $@ ${OBJS}
	${RANLIB} $@

libHYPRE_parcsr_block_mv.so libHYPRE_parcsr_block_mv.dylib: ${OBJS}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${OBJS} ${SHARED_SET_SONAME}${SONAME}
	ln -s ${SONAME} $@

${OBJS}: ${HEADERS}

${DRIVER_OBJS}: ${HEADERS}

=== src/parcsr_ls/Makefile ===
#BHEADER**********************************************************************
# Copyright (c) 2008,  Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory.
# This file is part of HYPRE.  See file COPYRIGHT for details.
#
# HYPRE is free software; you can redistribute it and/or modify it under the
# terms of the GNU Lesser General Public License (as published by the Free
# Software Foundation) version 2.1 dated February 1999.
#
# $Revision$
#EHEADER**********************************************************************

include ../config/Makefile.config

## Euclid specific macros taken from distributed_ls/Euclid

CINCLUDES = ${INCLUDES} ${MPIINCLUDE}

C_COMPILE_FLAGS =\
 -I..\
 -I../distributed_ls/Euclid\
 -I$(srcdir)\
 -I$(srcdir)/..\
 -I$(srcdir)/../blas\
 -I$(srcdir)/../lapack\
 -I$(srcdir)/../multivector\
 -I$(srcdir)/../utilities\
 -I$(srcdir)/../krylov\
 -I$(srcdir)/../seq_mv\
 -I$(srcdir)/../parcsr_mv\
 -I$(srcdir)/../distributed_matrix\
 -I$(srcdir)/../matrix_matrix\
 -I$(srcdir)/../IJ_mv\
 -I$(srcdir)/../parcsr_block_mv\
 $(DSUPERLU_INCLUDE)\
 ${CINCLUDES}

HEADERS =\
 HYPRE_parcsr_ls.h\
 _hypre_parcsr_ls.h\
 aux_interp.h\
 block_tridiag.h\
 Common.h\
 par_amg.h\
 schwarz.h

FILES =\
 amg_hybrid.c\
 aux_interp.c\
 F90_hypre_laplace.c\
 F90_HYPRE_parcsr_amg.c\
 F90_HYPRE_parcsr_bicgstab.c\
 F90_HYPRE_parcsr_block.c\
 F90_HYPRE_parcsr_cgnr.c\
 F90_HYPRE_parcsr_Euclid.c\
 F90_HYPRE_parcsr_gmres.c\
 F90_HYPRE_parcsr_cogmres.c\
 F90_HYPRE_parcsr_flexgmres.c\
 F90_HYPRE_parcsr_lgmres.c\
 F90_HYPRE_parcsr_hybrid.c\
 F90_HYPRE_parcsr_int.c\
 F90_HYPRE_parcsr_ParaSails.c\
 F90_HYPRE_parcsr_pcg.c\
 F90_HYPRE_parcsr_pilut.c\
 F90_HYPRE_parcsr_schwarz.c\
 F90_HYPRE_ams.c\
 gen_redcs_mat.c\
 HYPRE_parcsr_amg.c\
 HYPRE_parcsr_bicgstab.c\
 HYPRE_parcsr_block.c\
 HYPRE_parcsr_cgnr.c\
 HYPRE_parcsr_Euclid.c\
 HYPRE_parcsr_gmres.c\
 HYPRE_parcsr_cogmres.c\
 HYPRE_parcsr_flexgmres.c\
 HYPRE_parcsr_lgmres.c\
 HYPRE_parcsr_hybrid.c\
 HYPRE_parcsr_int.c\
 HYPRE_parcsr_mgr.c\
 HYPRE_parcsr_ParaSails.c\
 HYPRE_parcsr_pcg.c\
 HYPRE_parcsr_pilut.c\
 HYPRE_parcsr_schwarz.c\
 HYPRE_ams.c\
 HYPRE_ads.c\
 HYPRE_ame.c\
 par_amg.c\
 par_amg_setup.c\
 par_amg_solve.c\
 par_amg_solveT.c\
 par_cg_relax_wt.c\
 par_coarsen.c\
 par_cgc_coarsen.c\
 par_cheby.c\
 par_coarse_parms.c\
 par_coordinates.c\
 par_cr.c\
 par_cycle.c\
 par_add_cycle.c\
 par_difconv.c\
 par_gsmg.c\
 par_indepset.c\
 par_interp.c\
 par_jacobi_interp.c\
 par_multi_interp.c\
 par_laplace_27pt.c\
 par_laplace_9pt.c\
 par_laplace.c\
 par_lr_interp.c\
 par_mgr.c\
 par_mgr_setup.c\
 par_mgr_solve.c\
 par_nongalerkin.c\
 par_nodal_systems.c\
 par_rap.c\
 par_rap_communication.c\
 par_rotate_7pt.c\
 par_vardifconv.c\
 par_vardifconv_rs.c\
 par_relax.c\
 par_relax_more.c\
 par_relax_interface.c\
 par_scaled_matnorm.c\
 par_schwarz.c\
 par_stats.c\
 par_strength.c\
 par_sv_interp.c\
 par_sv_interp_ln.c\
 partial.c\
 pcg_par.c\
 schwarz.c\
 block_tridiag.c\
 ams.c\
 ads.c\
 ame.c\
 par_restr.c\
 par_lr_restr.c\
 superlu.c

OBJS = ${FILES:.c=.o}

SONAME = libHYPRE_parcsr_ls-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}

##################################################################
# Targets
##################################################################

all: libHYPRE_parcsr_ls${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_BUILD_DIR)/include
	cp -fR $(srcdir)/_hypre_parcsr_ls.h $(HYPRE_BUILD_DIR)/include
#	cp -fR libHYPRE* $(HYPRE_BUILD_DIR)/lib

install: libHYPRE_parcsr_ls${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_INC_INSTALL)
	cp -fR $(srcdir)/_hypre_parcsr_ls.h $(HYPRE_INC_INSTALL)
#	cp -fR libHYPRE* $(HYPRE_LIB_INSTALL)

clean:
	rm -f *.o libHYPRE*
	rm -rf pchdir tca.map *inslog*

distclean: clean


##################################################################
# Rules
##################################################################

libHYPRE_parcsr_ls.a: ${OBJS}
	@echo  "Building $@ ... "
	${AR} $@ ${OBJS}
	${RANLIB} $@

libHYPRE_parcsr_ls.so libHYPRE_parcsr_ls.dylib: ${OBJS}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${OBJS} ${SHARED_SET_SONAME}${SONAME}
	ln -s ${SONAME} $@

${OBJS}: ${HEADERS}

=== src/sstruct_ls/Makefile ===
#BHEADER**********************************************************************
# Copyright (c) 2008,  Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory.
# This file is part of HYPRE.  See file COPYRIGHT for details.
#
# HYPRE is free software; you can redistribute it and/or modify it under the
# terms of the GNU Lesser General Public License (as published by the Free
# Software Foundation) version 2.1 dated February 1999.
#
# $Revision$
#EHEADER**********************************************************************


include ../config/Makefile.config

CINCLUDES = ${INCLUDES} ${MPIINCLUDE}

C_COMPILE_FLAGS = \
 -I..\
 -I$(srcdir)\
 -I$(srcdir)/..\
 -I$(srcdir)/../multivector\
 -I$(srcdir)/../utilities\
 -I$(srcdir)/../krylov\
 -I$(srcdir)/../struct_mv\
 -I$(srcdir)/../seq_mv\
 -I$(srcdir)/../parcsr_mv\
 -I$(srcdir)/../IJ_mv\
 -I$(srcdir)/../sstruct_mv\
 -I$(srcdir)/../struct_ls\
 -I$(srcdir)/../parcsr_ls\
 $(SUPERLU_INCLUDE)\
 $(DSUPERLU_INCLUDE)\
 ${CINCLUDES}

HEADERS =\
 HYPRE_sstruct_ls.h\
 _hypre_sstruct_ls.h\
 fac.h\
 maxwell_TV.h\
 nd1_amge_interpolation.h\
 sstruct_owninfo.h\
 sstruct_recvinfo.h\
 sstruct_sendinfo.h\
 sys_pfmg.h

FILES =\
 F90_HYPRE_sstruct_bicgstab.c\
 F90_HYPRE_sstruct_gmres.c\
 F90_HYPRE_sstruct_flexgmres.c\
 F90_HYPRE_sstruct_lgmres.c\
 F90_HYPRE_sstruct_InterFAC.c\
 F90_HYPRE_sstruct_int.c\
 F90_HYPRE_sstruct_maxwell.c\
 F90_HYPRE_sstruct_pcg.c\
 F90_HYPRE_sstruct_split.c\
 F90_HYPRE_sstruct_sys_pfmg.c\
 HYPRE_sstruct_bicgstab.c\
 HYPRE_sstruct_gmres.c\
 HYPRE_sstruct_flexgmres.c\
 HYPRE_sstruct_lgmres.c\
 HYPRE_sstruct_InterFAC.c\
 HYPRE_sstruct_int.c\
 HYPRE_sstruct_maxwell.c\
 HYPRE_sstruct_pcg.c\
 HYPRE_sstruct_split.c\
 HYPRE_sstruct_sys_pfmg.c\
 fac.c\
 fac_amr_rap.c\
 fac_amr_fcoarsen.c\
 fac_amr_zero_data.c\
 fac_cf_coarsen.c\
 fac_cfstencil_box.c\
 fac_CFInterfaceExtents.c\
 fac_interp2.c\
 fac_relax.c\
 fac_restrict2.c\
 fac_setup2.c\
 fac_solve3.c\
 fac_zero_cdata.c\
 fac_zero_stencilcoef.c\
 hypre_bsearch.c\
 krylov.c\
 krylov_sstruct.c\
 eliminate_rowscols.c\
 maxwell_grad.c\
 maxwell_physbdy.c\
 maxwell_PNedelec.c\
 maxwell_PNedelec_bdy.c\
 maxwell_semi_interp.c\
 maxwell_TV.c\
 maxwell_TV_setup.c\
 maxwell_zeroBC.c\
 hypre_MaxwellSolve.c\
 hypre_MaxwellSolve2.c\
 nd1_amge_interpolation.c\
 node_relax.c\
 sstruct_amr_intercommunication.c\
 sstruct_owninfo.c\
 sstruct_recvinfo.c\
 sstruct_sendinfo.c\
 sstruct_sharedDOFComm.c\
 sys_pfmg.c\
 sys_pfmg_relax.c\
 sys_pfmg_setup.c\
 sys_pfmg_setup_interp.c\
 sys_pfmg_setup_rap.c\
 sys_pfmg_solve.c\
 sys_semi_interp.c\
 sys_semi_restrict.c

OBJS = ${FILES:.c=.o}

SONAME = libHYPRE_sstruct_ls-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}

##################################################################
# Targets
##################################################################

all: libHYPRE_sstruct_ls${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_BUILD_DIR)/include
	cp -fR $(srcdir)/_hypre_sstruct_ls.h $(HYPRE_BUILD_DIR)/include
#	cp -fR libHYPRE* $(HYPRE_BUILD_DIR)/lib

install: libHYPRE_sstruct_ls${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_INC_INSTALL)
	cp -fR $(srcdir)/_hypre_sstruct_ls.h $(HYPRE_INC_INSTALL)
#	cp -fR libHYPRE* $(HYPRE_LIB_INSTALL)

clean:
	rm -f *.o libHYPRE*
	rm -rf pchdir tca.map *inslog*

distclean: clean

##################################################################
# Rules
##################################################################

libHYPRE_sstruct_ls.a: ${OBJS}
	@echo  "Building $@ ... "
	${AR} $@ ${OBJS}
	${RANLIB} $@

libHYPRE_sstruct_ls.so libHYPRE_sstruct_ls.dylib: ${OBJS}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${OBJS} ${SHARED_SET_SONAME}${SONAME}
	ln -s ${SONAME} $@

${OBJS}: ${HEADERS}

=== src/struct_mv/Makefile ===
#BHEADER**********************************************************************
# Copyright (c) 2008,  Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory.
# This file is part of HYPRE.  See file COPYRIGHT for details.
#
# HYPRE is free software; you can redistribute it and/or modify it under the
# terms of the GNU Lesser General Public License (as published by the Free
# Software Foundation) version 2.1 dated February 1999.
#
# $Revision$
#EHEADER**********************************************************************

include ../config/Makefile.config

CINCLUDES = ${INCLUDES} ${MPIINCLUDE}

C_COMPILE_FLAGS = \
 -I..\
 -I$(srcdir)\
 -I$(srcdir)/..\
 -I$(srcdir)/../utilities\
 ${CINCLUDES}

HEADERS =\
 HYPRE_struct_mv.h\
 _hypre_struct_mv.h\
 assumed_part.h\
 box.h\
 box_manager.h\
 computation.h\
 struct_communication.h\
 struct_grid.h\
 struct_matrix.h\
 struct_stencil.h\
 struct_vector.h

FILES =\
 assumed_part.c\
 box_algebra.c\
 box_boundary.c\
 box.c\
 box_manager.c\
 communication_info.c\
 computation.c\
 F90_HYPRE_struct_grid.c\
 F90_HYPRE_struct_matrix.c\
 F90_HYPRE_struct_stencil.c\
 F90_HYPRE_struct_vector.c\
 HYPRE_struct_grid.c\
 HYPRE_struct_matrix.c\
 HYPRE_struct_stencil.c\
 HYPRE_struct_vector.c\
 project.c\
 struct_axpy.c\
 struct_communication.c\
 struct_copy.c\
 struct_grid.c\
 struct_innerprod.c\
 struct_io.c\
 struct_matrix.c\
 struct_matrix_mask.c\
 struct_matvec.c\
 struct_scale.c\
 struct_stencil.c\
 struct_vector.c

OBJS = ${FILES:.c=.o}

SONAME = libHYPRE_struct_mv-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}

##################################################################
# Targets
##################################################################

all: libHYPRE_struct_mv${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_BUILD_DIR)/include
	cp -fR $(srcdir)/_hypre_struct_mv.h $(HYPRE_BUILD_DIR)/include
#	cp -fR libHYPRE* $(HYPRE_BUILD_DIR)/lib

install: libHYPRE_struct_mv${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_INC_INSTALL)
	cp -fR $(srcdir)/_hypre_struct_mv.h $(HYPRE_INC_INSTALL)
#	cp -fR libHYPRE* $(HYPRE_LIB_INSTALL)

clean:
	rm -f *.o libHYPRE*
	rm -rf pchdir tca.map *inslog*

distclean: clean

##################################################################
# Rules
##################################################################

libHYPRE_struct_mv.a: ${OBJS}
	@echo  "Building $@ ... "
	${AR} $@ ${OBJS}
	${RANLIB} $@

libHYPRE_struct_mv.so libHYPRE_struct_mv.dylib: ${OBJS}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${OBJS} ${SHARED_SET_SONAME}${SONAME}
	ln -s ${SONAME} $@

${OBJS}: ${HEADERS}

=== src/test/Makefile ===
#BHEADER**********************************************************************
# Copyright (c) 2008,  Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory.
# This file is part of HYPRE.  See file COPYRIGHT for details.
#
# HYPRE is free software; you can redistribute it and/or modify it under the
# terms of the GNU Lesser General Public License (as published by the Free
# Software Foundation) version 2.1 dated February 1999.
#
# $Revision$
#EHEADER**********************************************************************

default:all

include ../config/Makefile.config

CINCLUDES = ${INCLUDES} ${MPIINCLUDE}

CDEFS = -DHYPRE_TIMING -DHYPRE_FORTRAN
CXXDEFS = -DNOFEI -DHYPRE_TIMING -DMPICH_SKIP_MPICXX

C_COMPILE_FLAGS = \
 -I$(srcdir)\
 -I$(srcdir)/..\
 -I${HYPRE_BUILD_DIR}/include\
 $(SUPERLU_INCLUDE)\
 $(DSUPERLU_INCLUDE)\
 ${CINCLUDES}\
 ${CDEFS}

CXX_COMPILE_FLAGS = \
 -I$(srcdir)\
 -I$(srcdir)/..\
 -I$(srcdir)/../FEI_mv/fei-base\
 -I${HYPRE_BUILD_DIR}/include\
 $(SUPERLU_INCLUDE)\
 $(DSUPERLU_INCLUDE)\
 ${CINCLUDES}\
 ${CXXDEFS}

F77_COMPILE_FLAGS = \
 -I$(srcdir)\
 -I$(srcdir)/..\
 -I${HYPRE_BUILD_DIR}/include\
 ${CINCLUDES}

MPILIBFLAGS = ${MPILIBDIRS} ${MPILIBS} ${MPIFLAGS} 
LAPACKLIBFLAGS = ${LAPACKLIBDIRS} ${LAPACKLIBS}
BLASLIBFLAGS = ${BLASLIBDIRS} ${BLASLIBS}
LIBFLAGS = ${LDFLAGS} ${LIBS}

ifeq (${LINK_CC}, nvcc)
   XLINK = -Xlinker=-rpath,${HYPRE_BUILD_DIR}/lib
else
   XLINK = -Wl,-rpath,${HYPRE_BUILD_DIR}/lib
endif

LFLAGS =\
 -L${HYPRE_BUILD_DIR}/lib -lHYPRE\
 ${XLINK}\
 ${DSUPERLU_LIBS}\
 ${SUPERLU_LIBS}\
 ${MPILIBFLAGS}\
 ${LAPACKLIBFLAGS}\
 ${BLASLIBFLAGS}\
 ${LIBFLAGS}

##################################################################
# Targets
##################################################################

HYPRE_DRIVERS =\
 ij.c\
 sstruct.c\
 struct.c\
 ams_driver.c\
 maxwell_unscaled.c\
 struct_migrate.c\
 sstruct_fac.c\
 ij_mv.c\
 zboxloop.c

HYPRE_DRIVERS_CXX =\
 fei.cxx\
 cxx_ij.cxx\
 cxx_sstruct.cxx\
 cxx_struct.cxx

HYPRE_F77_EXAMPLES_DRIVERS =\
 ex1_for.c\
 ex3_for.c\
 ex5_for.c\
 ex6_for.c\
 ex7_for.c

HYPRE_DRIVERS_F77 =\
 f77_ij.f\
 f77_ij_mv.f\
 f77_struct.f

HYPRE_DRIVER_EXECS=${HYPRE_DRIVERS:.c=}
HYPRE_F77_EXAMPLES_DRIVER_EXECS=${HYPRE_F77_EXAMPLES_DRIVERS:.c=}
HYPRE_DRIVER_F77_EXECS=${HYPRE_DRIVERS_F77:.f=}
HYPRE_DRIVER_CXX_EXECS=${HYPRE_DRIVERS_CXX:.cxx=}

all: ${HYPRE_DRIVER_EXECS}

all77: ${HYPRE_DRIVER_F77_EXECS}

all++: ${HYPRE_DRIVER_CXX_EXECS}

install:

clean:
	rm -f *.o
	rm -rf pchdir tca.map *inslog*

distclean: clean
	rm -f ${HYPRE_DRIVER_EXECS}
	rm -f ${HYPRE_F77_EXAMPLES_DRIVER_EXECS}
	rm -f ${HYPRE_DRIVER_F77_EXECS}
	rm -f ${HYPRE_DRIVER_CXX_EXECS} cxx_*
	rm -f TEST_examples/*.out*
	rm -f TEST_examples/*.err*
	rm -f TEST_fac/*.out*
	rm -f TEST_fac/*.err*
	rm -f TEST_ij/*.out*
	rm -f TEST_ij/*.err*
	rm -f TEST_ij/*.txt*
	rm -f TEST_ij/vectors.*
	rm -f TEST_sstruct/*.out*
	rm -f TEST_sstruct/*.err*
	rm -f TEST_struct/*.out*
	rm -f TEST_struct/*.err*
	rm -f ex1 ex2 ex3 ex4 ex5 ex5big ex5b ex5b77 ex6 ex7 ex8 ex9 ex15big ex18comp

##################################################################
# Rules
##################################################################

# C

ij: ij.o
	@echo  "Building" $@ "... "
	${LINK_CC} -o $@ $@.o ${LFLAGS}

sstruct: sstruct.o
	@echo  "Building" $@ "... "
	${LINK_CC} -o $@ $@.o ${LFLAGS}

struct: struct.o
	@echo  "Building" $@ "... "
	${LINK_CC} -o $@ $@.o ${LFLAGS}

ams_driver: ams_driver.o
	@echo  "Building" $@ "... "
	${LINK_CC} -o $@ $@.o ${LFLAGS}

maxwell_unscaled: maxwell_unscaled.o
	@echo  "Building" $@ "... "
	${LINK_CC} -o $@ $@.o ${LFLAGS}

struct_migrate: struct_migrate.o
	@echo  "Building" $@ "... "
	${LINK_CC} -o $@ $@.o ${LFLAGS}

sstruct_fac: sstruct_fac.o
	@echo  "Building" $@ "... "
	${LINK_CC} -o $@ $@.o ${LFLAGS}

ij_mv: ij_mv.o
	@echo  "Building" $@ "... "
	${LINK_CC} -o $@ $@.o ${LFLAGS}

zboxloop: zboxloop.o
	@echo  "Building" $@ "... "
	${LINK_CC} -o $@ $@.o ${LFLAGS}

struct_newboxloop: struct_newboxloop.o $(KOKKOS_LINK_DEPENDS)
	@echo  "Building" $@ "... "
	${LINK_CC} -o $@ $@.o ${LFLAGS}

# RDF: Keep these for now

hypre_set_precond: hypre_set_precond.o
	@echo  "Building" $@ "... "
	${LINK_CC} -o $@ $@.o ${LFLAGS}

test_ij: hypre_set_precond.o test_ij.o
	@echo  "Building" $@ "... "
	${LINK_CC} -o $@ hypre_set_precond.o $@.o ${LFLAGS}

driver_commpkg: driver_commpkg.o
	@echo  "Building" $@ "... "
	${LINK_CC} -o $@ $@.o ${LFLAGS}

# C++

fei: fei.o
	@echo  "Building" $@ "... "
	${LINK_CXX} -o $@ $@.o ${LFLAGS}

cxx_ij: cxx_ij.o
	@echo  "Building" $@ "... "
	${LINK_CXX} -o $@ $@.o ${LFLAGS}
cxx_ij.o: cxx_ij.cxx
cxx_ij.cxx: ij.c
	cp -fp ij.c cxx_ij.cxx

cxx_sstruct: cxx_sstruct.o
	@echo  "Building" $@ "... "
	${LINK_CXX} -o $@ $@.o ${LFLAGS}
cxx_sstruct.o: cxx_sstruct.cxx
cxx_sstruct.cxx: sstruct.c
	cp -fp sstruct.c cxx_sstruct.cxx

cxx_struct: cxx_struct.o
	@echo  "Building" $@ "... "
	${LINK_CXX} -o $@ $@.o ${LFLAGS}
cxx_struct.o: cxx_struct.cxx
cxx_struct.cxx: struct.c
	cp -fp struct.c cxx_struct.cxx

# Fortran

f77_ij: f77_ij.o
	@echo  "Building" $@ "... "
	${LINK_FC} -o $@ $@.o ${LFLAGS}

f77_ij_mv: f77_ij_mv.o
	@echo  "Building" $@ "... "
	${LINK_FC} -o $@ $@.o ${LFLAGS}

f77_struct: f77_struct.o
	@echo  "Building" $@ "... "
	${LINK_FC} -o $@ $@.o ${LFLAGS}

# RDF: Keep these for now

struct_for: fstruct_mv.o fstruct_ls.o struct_for.o
	@echo  "Building" $@ "... "
	${LINK_CC} -o $@ fstruct_mv.o fstruct_ls.o $@.o ${LFLAGS}

ex1_for: fstruct_mv.o fstruct_ls.o ex1_for.o
	@echo  "Building" $@ "... "
	${LINK_CC} -o $@ fstruct_mv.o fstruct_ls.o $@.o ${LFLAGS}

ex3_for: fstruct_mv.o fstruct_ls.o ex3_for.o
	@echo  "Building" $@ "... "
	${LINK_CC} -o $@ fstruct_mv.o fstruct_ls.o $@.o ${LFLAGS}

ex5_for: fij_mv.o fparcsr_mv.o fparcsr_ls.o ex5_for.o
	@echo  "Building" $@ "... "
	${LINK_CC} -o $@ fij_mv.o fparcsr_mv.o fparcsr_ls.o $@.o ${LFLAGS}

ex6_for: fstruct_mv.o fstruct_ls.o fsstruct_mv.o fsstruct_ls.o ex6_for.o
	@echo  "Building" $@ "... "
	${LINK_CC} -o $@ fstruct_mv.o fstruct_ls.o fsstruct_mv.o fsstruct_ls.o $@.o ${LFLAGS}

ex7_for: fstruct_mv.o fstruct_ls.o fsstruct_mv.o fsstruct_ls.o ex7_for.o
	@echo  "Building" $@ "... "
	${LINK_CC} -o $@ fstruct_mv.o fstruct_ls.o fsstruct_mv.o fsstruct_ls.o $@.o ${LFLAGS}

for_maxwell: fparcsr_mv.o fsstruct_mv.o fsstruct_ls.o for_maxwell.o
	@echo  "Building" $@ "... "
	${LINK_CC} -o $@ fparcsr_mv.o fsstruct_mv.o fsstruct_ls.o $@.o ${LFLAGS}

fij_mv: fij_mv.f
	@echo  "Building" $@ "... "
	${LINK_FC} -c $@

fparcsr_ls: fparcsr_ls.f
	@echo  "Building" $@ "... "
	${LINK_FC} -c $@

fparcsr_mv: fparcsr_mv.f
	@echo  "Building" $@ "... "
	${LINK_FC} -c $@

fsstruct_ls: fsstruct_ls.f 
	@echo  "Building" $@ "... "
	${LINK_FC} -c $@

fsstruct_mv: fsstruct_mv.f
	@echo  "Building" $@ "... "
	${LINK_FC} -c $@

fstruct_ls: fstruct_ls.f
	@echo  "Building" $@ "... "
	${LINK_FC} -c $@

fstruct_mv: fstruct_mv.f
	@echo  "Building" $@ "... "
	${LINK_FC} -c $@

=== src/utilities/Makefile ===
#BHEADER**********************************************************************
# Copyright (c) 2008,  Lawrence Livermore National Security, LLC.
# Produced at the Lawrence Livermore National Laboratory.
# This file is part of HYPRE.  See file COPYRIGHT for details.
#
# HYPRE is free software; you can redistribute it and/or modify it under the
# terms of the GNU Lesser General Public License (as published by the Free
# Software Foundation) version 2.1 dated February 1999.
#
# $Revision$
#EHEADER**********************************************************************

include ../config/Makefile.config

CINCLUDES = ${INCLUDES} ${MPIINCLUDE}
CDEFS = ${TIMERDEFS}

C_COMPILE_FLAGS =\
   -I..\
   -I$(srcdir)/..\
   -I$(srcdir)\
   ${CINCLUDES}\
   ${CDEFS}
CXX_COMPILE_FLAGS = ${C_COMPILE_FLAGS}

HEADERS =\
 amg_linklist.h\
 exchange_data.h\
 fortran.h\
 fortran_matrix.h\
 general.h\
 hypre_memory.h\
 HYPRE_utilities.h\
 mpistubs.h\
 threading.h\
 timing.h\
 _hypre_utilities.h

FILES =\
 HYPRE_version.c\
 amg_linklist.c\
 binsearch.c\
 exchange_data.c\
 fortran_matrix.c\
 hypre_ap.c\
 hypre_complex.c\
 hypre_memory.c\
 hypre_printf.c\
 hypre_qsort.c\
 mpistubs.c\
 qsplit.c\
 random.c\
 threading.c\
 timer.c\
 timing.c\
 hypre_mpi_comm_f2c.c\
 hypre_error.c\
 F90_HYPRE_error.c\
 hypre_prefix_sum.c\
 hypre_merge_sort.c\
 hypre_hopscotch_hash.c\
 gpuErrorCheck.c\
 gpuMem.c\
 hypre_general.c\
 hypre_reducesum.c

OBJS = ${FILES:.c=.o}

SONAME = libHYPRE_utilities-${HYPRE_RELEASE_VERSION}${HYPRE_LIB_SUFFIX}

##################################################################
# Targets
##################################################################

all: libHYPRE_utilities${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_BUILD_DIR)/include
	cp -fR $(srcdir)/_hypre_utilities.h $(HYPRE_BUILD_DIR)/include
	cp -fR $(srcdir)/hypre_hopscotch_hash.h $(HYPRE_BUILD_DIR)/include
	cp -fR $(srcdir)/fortran*.h $(HYPRE_BUILD_DIR)/include
#	cp -fR libHYPRE* $(HYPRE_BUILD_DIR)/lib

install: libHYPRE_utilities${HYPRE_LIB_SUFFIX}
	cp -fR $(srcdir)/HYPRE_*.h $(HYPRE_INC_INSTALL)
	cp -fR $(srcdir)/_hypre_utilities.h $(HYPRE_INC_INSTALL)
	cp -fR $(srcdir)/fortran*.h $(HYPRE_INC_INSTALL)
#	cp -fR libHYPRE* $(HYPRE_LIB_INSTALL)

clean:
	rm -f *.o libHYPRE*
	rm -rf pchdir tca.map *inslog*

distclean: clean

##################################################################
# Rules
##################################################################

libHYPRE_utilities.a: ${OBJS}
	@echo  "Building $@ ... "
	${AR} $@ *.o
	${RANLIB} $@

libHYPRE_utilities.so libHYPRE_utilities.dylib: ${OBJS}
	@echo  "Building $@ ... "
	${BUILD_CC_SHARED} -o ${SONAME} ${OBJS} ${SHARED_SET_SONAME}${SONAME}
	ln -s ${SONAME} $@

${OBJS}: ${HEADERS}

=== debian/changelog ===
hypre (2.15.1-5) unstable; urgency=medium

  * Team upload.
  * Add debian patches:
      fix_race_condition_b99fe77.patch
      fix_race_condition_97cd175.patch
      - applies upstream commits b99fe77 and 97cd175 (partial,
        removing new BigInt references), aiming to reduce test
        failures due to race conditions.
      - addresses Bug#910104.

 -- Drew Parsons <dparsons@debian.org>  Sat, 13 Apr 2019 11:30:08 +0800

hypre (2.15.1-4) unstable; urgency=medium

  * Team upload.
  * add armel to the no-test blacklist

 -- Drew Parsons <dparsons@debian.org>  Sat, 22 Dec 2018 12:01:40 +0100

hypre (2.15.1-3) unstable; urgency=medium

  * Team upload.
  * Disable build tests for ia64 (consistently times out).

 -- Drew Parsons <dparsons@debian.org>  Fri, 21 Dec 2018 22:54:58 +0100

hypre (2.15.1-2) unstable; urgency=medium

  * Team upload.
  * upload to unstable
    - note libHYPRE is now split into only 2 sublibs:
      libHYPRE_core.so and libHYPRE_FEI.so
      Link with '-lHYPRE_FEI -lHYPRE_core'
      (see README.Debian)
  * add libdir to LD_LIBRARY_PATH at build time only when running tests

 -- Drew Parsons <dparsons@debian.org>  Thu, 29 Nov 2018 22:53:15 +0800

hypre (2.15.1-1exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * reorganise sublibs to split libHYPRE into only 2 components:
       libHYPRE_core.so
       libHYPRE_FEI.so
    Circular dependencies between components prevent libHYPRE_core.so
    from being split further. Closes: #902102.
    - create new split libs in shlibs-interlink-libHYPRE.so.patch
    - drop install.patch, shlibs-interlink-sublibs.patch
    - test.patch: update link flags in src/test/Makefile
  * debian/rules dh_auto_clean: remove src/test/$TEST.{stdout,stderr}

 -- Drew Parsons <dparsons@debian.org>  Mon, 19 Nov 2018 13:07:30 +0800

=== debian/control ===
Source: hypre
Section: math
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: "Adam C. Powell, IV" <hazelsct@debian.org>
Standards-Version: 4.2.1
Build-Depends:
 autoconf,
 automake,
 debhelper (>= 11),
 pkg-config,
 gfortran,
 libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
 liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so,
 libsuperlu-dev, libsuperlu-dist-dev,
 libltdl-dev,
 libtool,
 mpi-default-dev,
Vcs-Git: https://salsa.debian.org/science-team/hypre.git
Vcs-Browser: https://salsa.debian.org/science-team/hypre
Homepage: http://www.llnl.gov/casc/hypre/

Package: libhypre-dev
Multi-Arch: same
Architecture: any
Section: libdevel
Depends:
 libhypre-2.15.1 (= ${binary:Version}),
 libopenblas-dev | libatlas-base-dev | libblas-dev | libblas.so,
 libopenblas-dev | libatlas-base-dev | liblapack-dev | liblapack.so,
 libsuperlu-dev,
 mpi-default-dev,
 ${misc:Depends},
Description: High Performance Matrix Preconditioners - Development Files
 Hypre is a set of matrix preconditioning libraries to aid in the solution of
 large systems of linear equations.
 .
 This package contains the headers and symlinks necessary to develop programs
 which use hypre.
 .
 To reduce the size of the library, HYPRE is split into sublibraries:
 libHYPRE.so is a dummy library linked to:
 - libHYPRE_core.so
 - libHYPRE_FEI.so

Package: libhypre-2.15.1
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: High Performance Matrix Preconditioners - Shared Library
 Hypre is a set of matrix preconditioning libraries to aid in the solution of
 large systems of linear equations.
 .
 This package contains the shared libraries.

=== debian/rules ===
#!/usr/bin/make -f
# Made with the aid of debmake, by Christoph Lameter,
# based on the sample debian/rules file for GNU hello by Ian Jackson.

DEB_VERSION := $(shell dpkg-parsechangelog -S Version)
DEB_NOEPOCH_VERSION := $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION := $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')

export HYPRE_SOVERSION=$(DEB_UPSTREAM_VERSION)

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic -O3
export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic -O3
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-as-needed
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

%:
	dh $@ --sourcedirectory=src --with autoreconf

# to avoid lintian warnings
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

# extra flags set to be similar to what petsc requires
extra_flags += \
  --with-fei --with-mli \
  --with-superlu --with-superlu-include=/usr/include/superlu --with-superlu-lib="-lsuperlu" \
  --with-dsuperlu --with-dsuperlu-include=/usr/include/superlu-dist --with-dsuperlu-lib="-lsuperlu_dist" \
  --with-blas --with-blas-lib="-lblas" \
  --with-lapack-libs="lapack" --with-lapack-lib-dirs="/usr/lib/lapack" --with-fmangle-lapack="one-underscore" \
  --with-MPI-include=$(shell pkg-config --cflags-only-I mpi | awk '{print $$1}' | sed "s/^-I//") \
  --with-MPI-libs="$(shell pkg-config --libs-only-l mpi | sed 's/-l//g')" \
  --with-MPI-lib-dirs="$(shell pkg-config --libs-only-L mpi | sed 's/-L//g')" \
  --with-MPI-flags="$(shell pkg-config --libs-only-other mpi)" \
  --with-extra-flags="($shell pkg-config --cflags-only-other mpi)" \
  --prefix=$(CURDIR)/debian/tmp/usr

# To get petsc support when indexTypes.integerSize == 64
#ifeq ($(DEB_HOST_ARCH),amd64)
#   extra_flags +=  --enable-bigint
#endif

# from pets:
# # explicitly tell hypre BLAS/LAPACK mangling since it may not match Fortran mangling
#    if self.blasLapack.mangling == 'underscore':
#      mang = 'one-underscore'
#    elif self.blasLapack.mangling == 'caps':
#      mang = 'caps-no-underscores'
#    else:
#      mang = 'no-underscores'
#    args.append('--with-fmangle-blas='+mang)
#    args.append('--with-fmangle-lapack='+mang)


# Other options from src/configure
  # --enable-debug          Set compiler flags for debugging.
  # --enable-shared         Build shared libraries (default is NO).
  # --enable-bigint         Use long long int for HYPRE_Int (default is NO).
  # --enable-complex        Use complex values (default is NO).
  # --enable-maxdim=MAXDIM  Change max dimension size to MAXDIM (default is 3).
  #                         Currently must be at least 3.
  # --enable-persistent     Uses persistent communication (default is NO).
  # --enable-hopscotch      Uses hopscotch hashing if configured with OpenMP and
  #                         atomic capability available(default is NO).
  # --enable-global-partition
  #                         Use global partitioning (default is NO).
  # --enable-fortran        Require a working Fortran compiler (default is YES).

export OMPI_MCA_orte_rsh_agent=/bin/false

override_dh_auto_clean:
	echo "Running clean"
	rm -rf $(CURDIR)/debian/tmp
	rm -f src/configure.in
	rm -f src/config.log
	rm -f src/config/config.guess
	rm -f src/config/config.sub
	cd src/test; \
	for TEST in TEST_*; do \
	  rm -f $${TEST}.stdout $${TEST}.stderr; \
	done
	-dh_auto_clean

override_dh_autoreconf:
	cp /usr/share/misc/config.* src/config/
	cd src && ./config/bootstrap

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags) --enable-shared
	#dh_auto_configure -p libhypre-complex -- $(extra_flags) --enable-shared --enable-complex


# disable build tests for these arches:
# ia64 consistently times out on tests
# armel occasionally times out
ARCH_NO_TEST_LIST = armel ia64

empty :=
space := $(empty)$(empty)

# run tests, or not
RUNTEST=yes
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(ARCH_NO_TEST_LIST)$(space)))
  RUNTEST=no
endif

override_dh_auto_test:
	set -e; \
	if [ "$(RUNTEST)" = "no" ]; then \
	  echo Tests have been disabled on $(DEB_HOST_ARCH); \
	else echo "Building tests"; \
	  $(MAKE) -C src test VERBOSE=1; \
	  echo "Running tests"; \
	  set -e; \
	  export LD_LIBRARY_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH):$(LD_LIBRARY_PATH); \
	  cd src/test; \
	  test_return="ok"; \
	  for TEST in TEST_*; do \
	    echo -n "running $${TEST} ... "; \
	    if ./runtest.sh -t $${TEST}/*.sh >$${TEST}.stdout 2>$${TEST}.stderr ; then \
	      echo ok; \
	    else \
	      test_return=$$?; \
	      echo "error found with error code $${test_return}"; \
	      echo "===== error logs for $${TEST} ====="; \
	      echo "$${TEST} stdout:"; \
	      cat $${TEST}.stdout; \
	      echo "$${TEST} stderr:"; \
	      cat $${TEST}.stderr; \
	      echo "===== end error logs for $${TEST} with error code $${test_return} ====="; \
	    fi; \
	  done; \
	  if [ $${test_return} != "ok" ]; then \
	      echo "Tests failed with last error code $${test_return}"; \
	      return $${test_return}; \
	  fi; \
	fi

# upstream places the soname in front of .so
# which makes it trickier than desirable to exclude
# the versioned so files in a libhypre-dev.install file
# Easier to just override instead
override_dh_install:
	dh_install -p libhypre-$(HYPRE_SOVERSION) usr/lib/*/*${HYPRE_SOVERSION}.so
	dh_install -p libhypre-dev --exclude=${HYPRE_SOVERSION} usr/lib/*/*
	dh_install -p libhypre-dev usr/include/hypre


# run examples (add -W, -no-as-needed on Unbuntu for ex5f)
#	echo "Building examples"
#	$(MAKE) -C src/examples \
#          HYPRE_LIB_INSTALL=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) \
#          HYPRE_INC_INSTALL=$(CURDIR)/debian/tmp/usr/include/hypre
#	ALLPROGS="ex1 ex2 ex3 ex4 ex5 ex5f \
#          ex6 ex7 ex8 ex9 ex11 ex12 ex12f" ; \
#	for ex in $$ALLPROGS; do \
#	   echo "Running $$ex"; \
#	   ls -l src/examples/$$ex; \
#	   mpirun -np 2 src/examples/$$ex ; \
#	done
#	ALLPROGS="ex13 ex14" ; \
#	for ex in $$ALLPROGS; do \
#	   echo "Running $$ex"; \
#	   mpirun -np 3 src/examples//$$ex ; \
#	done
#	ALLPROGS="ex15" ; \
#	for ex in $$ALLPROGS; do \
#	   echo "Running $$ex"; \
#	   mpirun -np 8 src/examples//$$ex ; \
#	done
#	ALLPROGS="ex16" ; \
#	for ex in $$ALLPROGS; do \
#	   echo "Running $$ex"; \
#	   mpirun -np 4 src/examples//$$ex ; \
#	done
#

# run testsuite

#	cd src/test; \
#	for file in `find . -name \*.sh | egrep "^./TEST" | egrep -v "fei|babel|timing"`; do \
#	   echo "./runtest.sh $$file" \
#	   ./runtest.sh $$file; \
#	done; \
#	cd ../..
